from django.shortcuts import render, redirect
from thingspace.exceptions import UnauthorizedError
from thingspace.exceptions import CloudError
from .forms import PlaylistForm
from .forms import CreateplaylistForm
from .forms import UpdateplaylistForm
from .forms import UpdateplaylistdefForm

def playlists(request):
    if not request.cloud.authenticated:
        return redirect('index')

    if request.method == 'POST':
        # create a form instance and populate it with data from the request:
        form = CreateplaylistForm(request.POST)
    else:
        form = CreateplaylistForm()

    try:
        if form.is_valid():
            createdplaylist = request.cloud.create_playlist(form.cleaned_data['name'], form.cleaned_data['type'])

        playlists = request.cloud.playlists()
        return render(request, 'playlist/playlists.html', {'playlists': playlists, 'form': form, 'actions': 'playlists'})
    except UnauthorizedError:
        return redirect('logout')
    except CloudError as error:
        return render(request, 'playlist/playlists.html', {error: error})


def playlist(request, uid):
    if not request.cloud.authenticated:
        return redirect('index')

    try:
        playlist = request.cloud.playlist(uid)
        items = request.cloud.playlist_items(uid)
    except UnauthorizedError:
        return redirect('logout')

    return render(request, 'playlist/playlist.html', {"playlist": playlist, "playlist_items": items})


def update_playlist_form(request, uid):

    form = UpdateplaylistForm()
    return render(request, 'playlist/updateplaylistform.html', {'form': form, 'uid': uid })

def update_playlist(request, uid):

    name = request.POST.get('name')
    type = request.POST.get('type')
    updated = request.cloud.update_playlist(uid, name, type)
    return render(request, 'playlist/updateplaylist.html', {'updated': updated })


def delete_playlist(request, uid):

    deleted = request.cloud.delete_playlist(uid)
    return redirect('playlists')


def delete_playlist_item(request, uid, item_uid):

    try:
        deleted = request.cloud.delete_playlist_item(uid, item_uid)
        return redirect('playlist', uid=uid)
    except UnauthorizedError:
        return redirect('logout')

def update_playlist_def_form(request, uid):

    form = UpdateplaylistdefForm()
    return render(request, 'playlist/updateplaylistdefform.html', {'form': form, 'uid': uid})


def update_playlist_def(request, uid):

    name = request.POST.get('name')
    paths = request.POST.get('paths')
    type = request.POST.get('type')
    updated_def = request.cloud.update_playlist_def(uid, name, paths, type)
    return render(request, 'playlist/updateplaylist.html', {'updated_def': updated_def })
