from thingspace.models.struct import Struct


class CloudFolder(Struct):

    def __init__(self, json):
        super(CloudFolder, self).__init__(json)


    def fullpath(self):
        if self.parent_path == '/':
            return '/' + self.name
        else:
            return self.parent_path + '/' + self.name

    def __eq__(self, other):
        if type(other) is type(self):
            if self.get('uri', None) and other.get('uri', None):
                return self.uri == other.uri
            else:
                return self.parent_path == other.parent_path and self.name == other.name
        else:
            return False

    def __ne__(self, other):
        return not self == other