from thingspace.models.share import Share
from thingspace.models.shares_cursor import SharesCursor
from thingspace.packages.requests.requests.packages.urllib3.packages.six.moves.urllib.parse import parse_qsl, urlparse


class SharesFactories:

    @staticmethod
    def sharecursor_from_json(json):

        links = json['shares'].get('links', [])
        next = None
        previous = None
        for link in links:

            cursor = dict(parse_qsl(urlparse(link['link']).query, keep_blank_values=True)).get('cursor')
            if link['rel'] == 'next':
                next = cursor
            elif link['rel'] == 'previous':
                previous = cursor

        total_count = json['shares'].get('count', 0)

        return SharesCursor(previous, next, total_count)


    @staticmethod
    def share_from_json(json):
        return Share(json)

    @staticmethod
    def shares_from_json(json):
        shares = []
        for share in json:
            shares.append(SharesFactories.share_from_json(share))
        return shares
