from thingspace.models.struct import Struct


class ShareRequest(Struct):

    def __init__(self, location, name, size=None, sub_type=None, type=None):
        super(ShareRequest, self).__init__()

        self.location = location
        self.name = name
        self.size = size
        self.sub_type = sub_type
        #for json body, the API uses camel case
        self.subType = sub_type
        self.type = type

    def validate(self):
        if not self.location:
            raise ValueError("ShareRequest location must be provided")
        if not self.name:
            raise ValueError("ShareRequest name must be provided")
        if self.type == 'file' and not self.size:
            raise ValueError("ShareRequest size required for shares of type 'file'")

