from thingspace.utils.json_helper import JsonHelper


class Struct(dict):
    """
    a dictionary that supports dot notation
    as well as dictionary access notation
    """

    __getattr__ = dict.__getitem__
    __setattr__ = dict.__setitem__
    __delattr__ = dict.__delitem__

    def __init__(self, dct={}):
        for key, value in dct.items():

            new_value = value
            if hasattr(value, 'keys'):
                new_value = Struct(value)
            elif isinstance(value, list):
                new_value = list()
                for val in value:
                    new_value.append(Struct(val))

            #convert camelCase to underscore
            self[JsonHelper.camel_to_underscore(key)] = new_value




